#include <sys/types.h>
#include "config.h"

#include "defs.h"
#include "xmodule.h"
#include "service.h"
#include "sconf.h"
#include "msg.h"
#include "timex.h"
#include "main.h"

status_e xinetd_sm_register(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	int i;
	char *interval = NULL;

	if( debug.on ) 
		msg(LOG_DEBUG, "time.so", "xinetd_sm_register entered");
	
	if( mc->config == NULL )
		return FAILED;

	mc->priv = (pset_h)pset_create( 0, 0 );
	if( mc->priv == NULL ) 
		return FAILED;

	for( i = 0; i < pset_count( mc->config ); i++ ) {
		interval = (char *) pset_pointer( mc->config, i );
		if( ti_add( mc->priv, interval ) == FAILED )
			return FAILED;
	}
	return OK;
}

status_e xinetd_sm_connect(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	if( debug.on ) 
		msg(LOG_DEBUG, "time.so", "xinetd_sm_connect entered");
	if( mc->priv == NULL )
		return OK;

	if( !ti_current_time_check( mc->priv ) )
		return FAILED;

	return OK;
}

status_e xinetd_sm_unregister(struct service *sp, struct module_conf *mc, connection_s *cp, void **arg)
{
	if( debug.on ) 
		msg(LOG_DEBUG, "time.so", "xinetd_sm_unregister entered");
	pset_destroy(mc->config);
	pset_destroy(mc->priv);
	mc->priv = NULL;
	mc->config = NULL;
	return OK;
}
